<template>
  <div class="pt-4 h-full">
    <div class="mb-10">
      <div v-for="item in data" :key="item.id" class="pb-3">
        <router-link :to="routeItem(item.nomorOrder)">
          <card-list :item="item"> </card-list>
        </router-link>
      </div>
      <div
        class="mt-2 py-2 flex items-center justify-center text-primary-blue text-base font-bold bg-whitesmoke rounded-xl cursor-pointer hover:bg-whitesmoke-darker"
        @click="nextPage"
      >
        SHOW MORE
      </div>
    </div>
  </div>
</template>

<script>
import { defineAsyncComponent } from "vue";

const cardList = defineAsyncComponent(() => import("./components/CardList"));

import { FETCH_LIST_ORDER } from "@/modules/order/store";

export default {
  components: {
    cardList,
  },

  data() {
    return {
      request: {
        tabChoosen:
          this.$route.params.tabChoosen === undefined
            ? "upcoming"
            : this.$route.params.tabChoosen,
        page: 0,
      },
      data: [],
    };
  },

  watch: {
    "$route.params.tabChoosen"(value) {
      if (value != undefined && this.request.tabChoosen != value) {
        this.data = [];
        this.request.tabChoosen = value;
      }
    },

    request: {
      deep: true,
      handler() {
        this.getData();
      },
    },
  },

  mounted() {
    this.getData();
  },

  methods: {
    nextPage() {
      this.request.page++;
    },

    getData() {
      let request = {
        type: this.request.tabChoosen,
        page: this.request.page,
        limit: 5,
        isDeleted: false,
      };

      this.$store.dispatch(FETCH_LIST_ORDER, request).then((data) => {
        this.data.push(
          ...data.content.map((content) => {
            return content;
          })
        );
      });
    },

    routeItem(nomorOrder) {
      const nomorOrderEncode = encodeURIComponent(nomorOrder).replace(
        /'/g,
        "%27"
      );
      return `/transaction/order/${this.$route.params.tabChoosen}/${nomorOrderEncode}`;
    },
  },
};
</script>
